<?php

namespace Lc\CaracoleBundle\Model\Setting;

use Lc\CaracoleBundle\Model\Section\SectionInterface;
use Doctrine\ORM\Mapping as ORM;
use Lc\SovBundle\Doctrine\EntityInterface;

abstract class SectionSettingModel implements SettingInterface, EntityInterface
{
    use SettingTrait;

    /**
     * @ORM\ManyToOne(targetEntity="Lc\CaracoleBundle\Model\Section\SectionInterface", inversedBy="settings")
     * @ORM\JoinColumn(nullable=false)
     */
    protected $section;

    public function getSection(): ?SectionInterface
    {
        return $this->section;
    }

    public function setSection(?SectionInterface $section): self
    {
        $this->section = $section;

        return $this;
    }
}